## What does it do?

### Field type

This module provides a new field type called "Google sheets table" which accepts a Google sheet spreadsheet ID and converts it into an HTML table. This HTML is stored in the database and can be rendered like a text field, exported to a decoupled app or used however else you like!

### Cron task

Additionally, it provides a cron task that automatically checks if the linked Google sheets have any new revisions and updates the respective HTML tables in the database.

## How do I authenticate this module with Google?

Follow [Google's instructions to create a user-managed Service account](https://cloud.google.com/iam/docs/service-accounts). Create a key for this Service account (choose JSON) and download the JSON file. Then store the JSON file as a multi-value key using the [Key module](https://www.drupal.org/project/key). On your Drupal site, go to `/admin/config/services/google-sheets-table` and choose the Key you just created as the Google sheets API key. Now the module can view any Google sheets that the Service account has access to. Note that this module does not require write permissions and will only ever read data from Google sheets.

## What is a spreadsheet ID?

The spreadsheet ID is the randomized string of characters in the url of the spreadsheet after `/spreadsheets/d/`. For example, this spreadsheet https://docs.google.com/spreadsheets/d/1BxiMVs0XRA5nFMdKvBdBZjgmUUqptlbs74OgvE2upms/edit#gid=0 has an ID of `1BxiMVs0XRA5nFMdKvBdBZjgmUUqptlbs74OgvE2upms`.
See the official [Google Sheets API](https://developers.google.com/sheets/api/guides/concepts) for more information on their terminology.

## Logo image credits:

- Down arrow by Rahmat Hidayat from [Noun Project](https://thenounproject.com/browse/icons/term/down-arrow/)
- Table by LAFS from [Noun Project](https://thenounproject.com/browse/icons/term/table/)
- Screen of computer by verry poernomo from [Noun Project](https://thenounproject.com/browse/icons/term/screen-of-computer/)
